Index: uspace/lib/c/include/inet/hostport.h
===================================================================
--- uspace/lib/c/include/inet/hostport.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/inet/hostport.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,9 +40,9 @@
 #include <types/inet/hostport.h>
 
-extern errno_t inet_hostport_parse(const char *, inet_hostport_t **, char **);
-extern errno_t inet_hostport_format(inet_hostport_t *, char **);
+extern int inet_hostport_parse(const char *, inet_hostport_t **, char **);
+extern int inet_hostport_format(inet_hostport_t *, char **);
 extern void inet_hostport_destroy(inet_hostport_t *);
-extern errno_t inet_hostport_lookup_one(inet_hostport_t *, ip_ver_t, inet_ep_t *);
-extern errno_t inet_hostport_plookup_one(const char *, ip_ver_t, inet_ep_t *,
+extern int inet_hostport_lookup_one(inet_hostport_t *, ip_ver_t, inet_ep_t *);
+extern int inet_hostport_plookup_one(const char *, ip_ver_t, inet_ep_t *,
     char **, const char **);
 
Index: uspace/lib/c/include/inet/inet.h
===================================================================
--- uspace/lib/c/include/inet/inet.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/inet/inet.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,7 +41,7 @@
 #include <types/inet.h>
 
-extern errno_t inet_init(uint8_t, inet_ev_ops_t *);
-extern errno_t inet_send(inet_dgram_t *, uint8_t, inet_df_t);
-extern errno_t inet_get_srcaddr(inet_addr_t *, uint8_t, inet_addr_t *);
+extern int inet_init(uint8_t, inet_ev_ops_t *);
+extern int inet_send(inet_dgram_t *, uint8_t, inet_df_t);
+extern int inet_get_srcaddr(inet_addr_t *, uint8_t, inet_addr_t *);
 
 #endif
Index: uspace/lib/c/include/inet/inetcfg.h
===================================================================
--- uspace/lib/c/include/inet/inetcfg.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/inet/inetcfg.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,20 +40,20 @@
 #include <types/inetcfg.h>
 
-extern errno_t inetcfg_init(void);
-extern errno_t inetcfg_addr_create_static(const char *, inet_naddr_t *, sysarg_t, sysarg_t *);
-extern errno_t inetcfg_addr_delete(sysarg_t);
-extern errno_t inetcfg_addr_get(sysarg_t, inet_addr_info_t *);
-extern errno_t inetcfg_addr_get_id(const char *, sysarg_t, sysarg_t *);
-extern errno_t inetcfg_get_addr_list(sysarg_t **, size_t *);
-extern errno_t inetcfg_get_link_list(sysarg_t **, size_t *);
-extern errno_t inetcfg_get_sroute_list(sysarg_t **, size_t *);
-extern errno_t inetcfg_link_add(sysarg_t);
-extern errno_t inetcfg_link_get(sysarg_t, inet_link_info_t *);
-extern errno_t inetcfg_link_remove(sysarg_t);
-extern errno_t inetcfg_sroute_get(sysarg_t, inet_sroute_info_t *);
-extern errno_t inetcfg_sroute_get_id(const char *, sysarg_t *);
-extern errno_t inetcfg_sroute_create(const char *, inet_naddr_t *, inet_addr_t *,
+extern int inetcfg_init(void);
+extern int inetcfg_addr_create_static(const char *, inet_naddr_t *, sysarg_t, sysarg_t *);
+extern int inetcfg_addr_delete(sysarg_t);
+extern int inetcfg_addr_get(sysarg_t, inet_addr_info_t *);
+extern int inetcfg_addr_get_id(const char *, sysarg_t, sysarg_t *);
+extern int inetcfg_get_addr_list(sysarg_t **, size_t *);
+extern int inetcfg_get_link_list(sysarg_t **, size_t *);
+extern int inetcfg_get_sroute_list(sysarg_t **, size_t *);
+extern int inetcfg_link_add(sysarg_t);
+extern int inetcfg_link_get(sysarg_t, inet_link_info_t *);
+extern int inetcfg_link_remove(sysarg_t);
+extern int inetcfg_sroute_get(sysarg_t, inet_sroute_info_t *);
+extern int inetcfg_sroute_get_id(const char *, sysarg_t *);
+extern int inetcfg_sroute_create(const char *, inet_naddr_t *, inet_addr_t *,
     sysarg_t *);
-extern errno_t inetcfg_sroute_delete(sysarg_t);
+extern int inetcfg_sroute_delete(sysarg_t);
 
 #endif
Index: uspace/lib/c/include/inet/inetping.h
===================================================================
--- uspace/lib/c/include/inet/inetping.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/inet/inetping.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,10 +40,10 @@
 
 typedef struct inetping_ev_ops {
-	errno_t (*recv)(inetping_sdu_t *);
+	int (*recv)(inetping_sdu_t *);
 } inetping_ev_ops_t;
 
-extern errno_t inetping_init(inetping_ev_ops_t *);
-extern errno_t inetping_send(inetping_sdu_t *);
-extern errno_t inetping_get_srcaddr(const inet_addr_t *, inet_addr_t *);
+extern int inetping_init(inetping_ev_ops_t *);
+extern int inetping_send(inetping_sdu_t *);
+extern int inetping_get_srcaddr(const inet_addr_t *, inet_addr_t *);
 
 #endif
Index: uspace/lib/c/include/inet/iplink.h
===================================================================
--- uspace/lib/c/include/inet/iplink.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/inet/iplink.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -78,17 +78,17 @@
 
 typedef struct iplink_ev_ops {
-	errno_t (*recv)(iplink_t *, iplink_recv_sdu_t *, ip_ver_t);
-	errno_t (*change_addr)(iplink_t *, addr48_t);
+	int (*recv)(iplink_t *, iplink_recv_sdu_t *, ip_ver_t);
+	int (*change_addr)(iplink_t *, addr48_t);
 } iplink_ev_ops_t;
 
-extern errno_t iplink_open(async_sess_t *, iplink_ev_ops_t *, void *, iplink_t **);
+extern int iplink_open(async_sess_t *, iplink_ev_ops_t *, void *, iplink_t **);
 extern void iplink_close(iplink_t *);
-extern errno_t iplink_send(iplink_t *, iplink_sdu_t *);
-extern errno_t iplink_send6(iplink_t *, iplink_sdu6_t *);
-extern errno_t iplink_addr_add(iplink_t *, inet_addr_t *);
-extern errno_t iplink_addr_remove(iplink_t *, inet_addr_t *);
-extern errno_t iplink_get_mtu(iplink_t *, size_t *);
-extern errno_t iplink_get_mac48(iplink_t *, addr48_t *);
-extern errno_t iplink_set_mac48(iplink_t *, addr48_t);
+extern int iplink_send(iplink_t *, iplink_sdu_t *);
+extern int iplink_send6(iplink_t *, iplink_sdu6_t *);
+extern int iplink_addr_add(iplink_t *, inet_addr_t *);
+extern int iplink_addr_remove(iplink_t *, inet_addr_t *);
+extern int iplink_get_mtu(iplink_t *, size_t *);
+extern int iplink_get_mac48(iplink_t *, addr48_t *);
+extern int iplink_set_mac48(iplink_t *, addr48_t);
 extern void *iplink_get_userptr(iplink_t *);
 
Index: uspace/lib/c/include/inet/iplink_srv.h
===================================================================
--- uspace/lib/c/include/inet/iplink_srv.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/inet/iplink_srv.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -53,20 +53,20 @@
 
 typedef struct iplink_ops {
-	errno_t (*open)(iplink_srv_t *);
-	errno_t (*close)(iplink_srv_t *);
-	errno_t (*send)(iplink_srv_t *, iplink_sdu_t *);
-	errno_t (*send6)(iplink_srv_t *, iplink_sdu6_t *);
-	errno_t (*get_mtu)(iplink_srv_t *, size_t *);
-	errno_t (*get_mac48)(iplink_srv_t *, addr48_t *);
-	errno_t (*set_mac48)(iplink_srv_t *, addr48_t *);
-	errno_t (*addr_add)(iplink_srv_t *, inet_addr_t *);
-	errno_t (*addr_remove)(iplink_srv_t *, inet_addr_t *);
+	int (*open)(iplink_srv_t *);
+	int (*close)(iplink_srv_t *);
+	int (*send)(iplink_srv_t *, iplink_sdu_t *);
+	int (*send6)(iplink_srv_t *, iplink_sdu6_t *);
+	int (*get_mtu)(iplink_srv_t *, size_t *);
+	int (*get_mac48)(iplink_srv_t *, addr48_t *);
+	int (*set_mac48)(iplink_srv_t *, addr48_t *);
+	int (*addr_add)(iplink_srv_t *, inet_addr_t *);
+	int (*addr_remove)(iplink_srv_t *, inet_addr_t *);
 } iplink_ops_t;
 
 extern void iplink_srv_init(iplink_srv_t *);
 
-extern errno_t iplink_conn(ipc_callid_t, ipc_call_t *, void *);
-extern errno_t iplink_ev_recv(iplink_srv_t *, iplink_recv_sdu_t *, ip_ver_t);
-extern errno_t iplink_ev_change_addr(iplink_srv_t *, addr48_t *);
+extern int iplink_conn(ipc_callid_t, ipc_call_t *, void *);
+extern int iplink_ev_recv(iplink_srv_t *, iplink_recv_sdu_t *, ip_ver_t);
+extern int iplink_ev_change_addr(iplink_srv_t *, addr48_t *);
 
 #endif
Index: uspace/lib/c/include/inet/tcp.h
===================================================================
--- uspace/lib/c/include/inet/tcp.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/inet/tcp.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -98,23 +98,23 @@
 } tcp_t;
 
-extern errno_t tcp_create(tcp_t **);
+extern int tcp_create(tcp_t **);
 extern void tcp_destroy(tcp_t *);
-extern errno_t tcp_conn_create(tcp_t *, inet_ep2_t *, tcp_cb_t *, void *,
+extern int tcp_conn_create(tcp_t *, inet_ep2_t *, tcp_cb_t *, void *,
     tcp_conn_t **);
 extern void tcp_conn_destroy(tcp_conn_t *);
 extern void *tcp_conn_userptr(tcp_conn_t *);
-extern errno_t tcp_listener_create(tcp_t *, inet_ep_t *, tcp_listen_cb_t *, void *,
+extern int tcp_listener_create(tcp_t *, inet_ep_t *, tcp_listen_cb_t *, void *,
     tcp_cb_t *, void *, tcp_listener_t **);
 extern void tcp_listener_destroy(tcp_listener_t *);
 extern void *tcp_listener_userptr(tcp_listener_t *);
 
-extern errno_t tcp_conn_wait_connected(tcp_conn_t *);
-extern errno_t tcp_conn_send(tcp_conn_t *, const void *, size_t);
-extern errno_t tcp_conn_send_fin(tcp_conn_t *);
-extern errno_t tcp_conn_push(tcp_conn_t *);
-extern errno_t tcp_conn_reset(tcp_conn_t *);
+extern int tcp_conn_wait_connected(tcp_conn_t *);
+extern int tcp_conn_send(tcp_conn_t *, const void *, size_t);
+extern int tcp_conn_send_fin(tcp_conn_t *);
+extern int tcp_conn_push(tcp_conn_t *);
+extern int tcp_conn_reset(tcp_conn_t *);
 
-extern errno_t tcp_conn_recv(tcp_conn_t *, void *, size_t, size_t *);
-extern errno_t tcp_conn_recv_wait(tcp_conn_t *, void *, size_t, size_t *);
+extern int tcp_conn_recv(tcp_conn_t *, void *, size_t, size_t *);
+extern int tcp_conn_recv_wait(tcp_conn_t *, void *, size_t, size_t *);
 
 
Index: uspace/lib/c/include/inet/udp.h
===================================================================
--- uspace/lib/c/include/inet/udp.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/inet/udp.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -91,14 +91,14 @@
 } udp_t;
 
-extern errno_t udp_create(udp_t **);
+extern int udp_create(udp_t **);
 extern void udp_destroy(udp_t *);
-extern errno_t udp_assoc_create(udp_t *, inet_ep2_t *, udp_cb_t *, void *,
+extern int udp_assoc_create(udp_t *, inet_ep2_t *, udp_cb_t *, void *,
     udp_assoc_t **);
-extern errno_t udp_assoc_set_nolocal(udp_assoc_t *);
+extern int udp_assoc_set_nolocal(udp_assoc_t *);
 extern void udp_assoc_destroy(udp_assoc_t *);
-extern errno_t udp_assoc_send_msg(udp_assoc_t *, inet_ep_t *, void *, size_t);
+extern int udp_assoc_send_msg(udp_assoc_t *, inet_ep_t *, void *, size_t);
 extern void *udp_assoc_userptr(udp_assoc_t *);
 extern size_t udp_rmsg_size(udp_rmsg_t *);
-extern errno_t udp_rmsg_read(udp_rmsg_t *, size_t, void *, size_t);
+extern int udp_rmsg_read(udp_rmsg_t *, size_t, void *, size_t);
 extern void udp_rmsg_remote_ep(udp_rmsg_t *, inet_ep_t *);
 extern uint8_t udp_rerr_type(udp_rerr_t *);
Index: uspace/lib/c/include/inttypes.h
===================================================================
--- uspace/lib/c/include/inttypes.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/inttypes.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -38,11 +38,4 @@
 #include <_bits/inttypes.h>
 
-#ifndef __HELENOS_DISABLE_INTMAX__
-intmax_t strtoimax(const char *__restrict__ nptr,
-    char **__restrict__ endptr, int base);
-uintmax_t strtoumax(const char *__restrict__ nptr,
-    char **__restrict__ endptr, int base);
-#endif
-
 #endif
 
Index: uspace/lib/c/include/io/chardev.h
===================================================================
--- uspace/lib/c/include/io/chardev.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/io/chardev.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,8 +41,8 @@
 } chardev_t;
 
-extern errno_t chardev_open(async_sess_t *, chardev_t **);
+extern int chardev_open(async_sess_t *, chardev_t **);
 extern void chardev_close(chardev_t *);
-extern errno_t chardev_read(chardev_t *, void *, size_t, size_t *);
-extern errno_t chardev_write(chardev_t *, const void *, size_t, size_t *);
+extern int chardev_read(chardev_t *, void *, size_t, size_t *);
+extern int chardev_write(chardev_t *, const void *, size_t, size_t *);
 
 #endif
Index: uspace/lib/c/include/io/chardev_srv.h
===================================================================
--- uspace/lib/c/include/io/chardev_srv.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/io/chardev_srv.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -57,8 +57,8 @@
 
 struct chardev_ops {
-	errno_t (*open)(chardev_srvs_t *, chardev_srv_t *);
-	errno_t (*close)(chardev_srv_t *);
-	errno_t (*read)(chardev_srv_t *, void *, size_t, size_t *);
-	errno_t (*write)(chardev_srv_t *, const void *, size_t, size_t *);
+	int (*open)(chardev_srvs_t *, chardev_srv_t *);
+	int (*close)(chardev_srv_t *);
+	int (*read)(chardev_srv_t *, void *, size_t, size_t *);
+	int (*write)(chardev_srv_t *, const void *, size_t, size_t *);
 	void (*def_handler)(chardev_srv_t *, ipc_callid_t, ipc_call_t *);
 };
@@ -66,5 +66,5 @@
 extern void chardev_srvs_init(chardev_srvs_t *);
 
-extern errno_t chardev_conn(ipc_callid_t, ipc_call_t *, chardev_srvs_t *);
+extern int chardev_conn(ipc_callid_t, ipc_call_t *, chardev_srvs_t *);
 
 #endif
Index: uspace/lib/c/include/io/con_srv.h
===================================================================
--- uspace/lib/c/include/io/con_srv.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/io/con_srv.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -67,14 +67,14 @@
 
 struct con_ops {
-	errno_t (*open)(con_srvs_t *, con_srv_t *);
-	errno_t (*close)(con_srv_t *);
-	errno_t (*read)(con_srv_t *, void *, size_t, size_t *);
-	errno_t (*write)(con_srv_t *, void *, size_t, size_t *);
+	int (*open)(con_srvs_t *, con_srv_t *);
+	int (*close)(con_srv_t *);
+	int (*read)(con_srv_t *, void *, size_t);
+	int (*write)(con_srv_t *, void *, size_t);
 	void (*sync)(con_srv_t *);
 	void (*clear)(con_srv_t *);
 	void (*set_pos)(con_srv_t *, sysarg_t col, sysarg_t row);
-	errno_t (*get_pos)(con_srv_t *, sysarg_t *, sysarg_t *);
-	errno_t (*get_size)(con_srv_t *, sysarg_t *, sysarg_t *);
-	errno_t (*get_color_cap)(con_srv_t *, console_caps_t *);
+	int (*get_pos)(con_srv_t *, sysarg_t *, sysarg_t *);
+	int (*get_size)(con_srv_t *, sysarg_t *, sysarg_t *);
+	int (*get_color_cap)(con_srv_t *, console_caps_t *);
 	void (*set_style)(con_srv_t *, console_style_t);
 	void (*set_color)(con_srv_t *, console_color_t, console_color_t,
@@ -82,10 +82,10 @@
 	void (*set_rgb_color)(con_srv_t *, pixel_t, pixel_t);
 	void (*set_cursor_visibility)(con_srv_t *, bool);
-	errno_t (*get_event)(con_srv_t *, cons_event_t *);
+	int (*get_event)(con_srv_t *, cons_event_t *);
 };
 
 extern void con_srvs_init(con_srvs_t *);
 
-extern errno_t con_conn(ipc_callid_t, ipc_call_t *, con_srvs_t *);
+extern int con_conn(ipc_callid_t, ipc_call_t *, con_srvs_t *);
 
 #endif
Index: uspace/lib/c/include/io/console.h
===================================================================
--- uspace/lib/c/include/io/console.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/io/console.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -73,6 +73,6 @@
 extern void console_clear(console_ctrl_t *);
 
-extern errno_t console_get_size(console_ctrl_t *, sysarg_t *, sysarg_t *);
-extern errno_t console_get_pos(console_ctrl_t *, sysarg_t *, sysarg_t *);
+extern int console_get_size(console_ctrl_t *, sysarg_t *, sysarg_t *);
+extern int console_get_pos(console_ctrl_t *, sysarg_t *, sysarg_t *);
 extern void console_set_pos(console_ctrl_t *, sysarg_t, sysarg_t);
 
@@ -82,5 +82,5 @@
 
 extern void console_cursor_visibility(console_ctrl_t *, bool);
-extern errno_t console_get_color_cap(console_ctrl_t *, sysarg_t *);
+extern int console_get_color_cap(console_ctrl_t *, sysarg_t *);
 extern bool console_get_event(console_ctrl_t *, cons_event_t *);
 extern bool console_get_event_timeout(console_ctrl_t *, cons_event_t *,
Index: uspace/lib/c/include/io/input.h
===================================================================
--- uspace/lib/c/include/io/input.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/io/input.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -48,15 +48,15 @@
 
 typedef struct input_ev_ops {
-	errno_t (*active)(input_t *);
-	errno_t (*deactive)(input_t *);
-	errno_t (*key)(input_t *, kbd_event_type_t, keycode_t, keymod_t, wchar_t);
-	errno_t (*move)(input_t *, int, int);
-	errno_t (*abs_move)(input_t *, unsigned, unsigned, unsigned, unsigned);
-	errno_t (*button)(input_t *, int, int);
+	int (*active)(input_t *);
+	int (*deactive)(input_t *);
+	int (*key)(input_t *, kbd_event_type_t, keycode_t, keymod_t, wchar_t);
+	int (*move)(input_t *, int, int);
+	int (*abs_move)(input_t *, unsigned, unsigned, unsigned, unsigned);
+	int (*button)(input_t *, int, int);
 } input_ev_ops_t;
 
-extern errno_t input_open(async_sess_t *, input_ev_ops_t *, void *, input_t **);
+extern int input_open(async_sess_t *, input_ev_ops_t *, void *, input_t **);
 extern void input_close(input_t *);
-extern errno_t input_activate(input_t *);
+extern int input_activate(input_t *);
 
 #endif
Index: uspace/lib/c/include/io/kio.h
===================================================================
--- uspace/lib/c/include/io/kio.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/io/kio.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,12 +39,10 @@
 #include <stdarg.h>
 #include <io/verify.h>
-#include <_bits/errno.h>
-#include <_bits/size_t.h>
 
-extern errno_t kio_write(const void *, size_t, size_t *);
+extern int kio_write(const void *, size_t, size_t *);
 extern void kio_update(void);
 extern void kio_command(const void *, size_t);
 extern int kio_printf(const char *, ...)
-    _HELENOS_PRINTF_ATTRIBUTE(1, 2);
+    PRINTF_ATTRIBUTE(1, 2);
 extern int kio_vprintf(const char *, va_list);
 
Index: uspace/lib/c/include/io/klog.h
===================================================================
--- uspace/lib/c/include/io/klog.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/io/klog.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -44,15 +44,20 @@
 #include <abi/log.h>
 
-extern errno_t klog_write(log_level_t, const void *, size_t);
-extern errno_t klog_read(void *, size_t, size_t *);
+extern size_t klog_write(log_level_t, const void *, size_t);
+extern int klog_read(void *, size_t);
 
 #define KLOG_PRINTF(lvl, fmt, ...) ({ \
+	char *_fmt = str_dup(fmt); \
+	size_t _fmtsize = str_size(_fmt); \
+	if (_fmtsize > 0 && _fmt[_fmtsize - 1] == '\n') \
+		_fmt[_fmtsize - 1] = 0; \
 	char *_s; \
-	errno_t _rc = ENOMEM; \
-	if (asprintf(&_s, fmt, ##__VA_ARGS__) >= 0) { \
-		_rc = klog_write((lvl), _s, str_size(_s)); \
+	int _c = asprintf(&_s, _fmt, ##__VA_ARGS__); \
+	free(_fmt); \
+	if (_c >= 0) { \
+		_c = klog_write((lvl), _s, str_size(_s)); \
 		free(_s); \
 	}; \
-	(_rc != EOK); \
+	(_c >= 0); \
 })
 
Index: uspace/lib/c/include/io/log.h
===================================================================
--- uspace/lib/c/include/io/log.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/io/log.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -54,11 +54,11 @@
 
 extern const char *log_level_str(log_level_t);
-extern errno_t log_level_from_str(const char *, log_level_t *);
+extern int log_level_from_str(const char *, log_level_t *);
 
-extern errno_t log_init(const char *);
+extern int log_init(const char *);
 extern log_t log_create(const char *, log_t);
 
 extern void log_msg(log_t, log_level_t, const char *, ...)
-    _HELENOS_PRINTF_ATTRIBUTE(3, 4);
+    PRINTF_ATTRIBUTE(3, 4);
 extern void log_msgv(log_t, log_level_t, const char *, va_list);
 
Index: uspace/lib/c/include/io/logctl.h
===================================================================
--- uspace/lib/c/include/io/logctl.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/io/logctl.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,7 +36,7 @@
 #include <io/log.h>
 
-extern errno_t logctl_set_default_level(log_level_t);
-extern errno_t logctl_set_log_level(const char *, log_level_t);
-extern errno_t logctl_set_root(void);
+extern int logctl_set_default_level(log_level_t);
+extern int logctl_set_log_level(const char *, log_level_t);
+extern int logctl_set_root(void);
 
 #endif
Index: uspace/lib/c/include/io/output.h
===================================================================
--- uspace/lib/c/include/io/output.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/io/output.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,16 +40,16 @@
 #include <io/console.h>
 
-extern errno_t output_yield(async_sess_t *);
-extern errno_t output_claim(async_sess_t *);
-extern errno_t output_get_dimensions(async_sess_t *, sysarg_t *, sysarg_t *);
-extern errno_t output_get_caps(async_sess_t *, console_caps_t *);
+extern int output_yield(async_sess_t *);
+extern int output_claim(async_sess_t *);
+extern int output_get_dimensions(async_sess_t *, sysarg_t *, sysarg_t *);
+extern int output_get_caps(async_sess_t *, console_caps_t *);
 
 extern frontbuf_handle_t output_frontbuf_create(async_sess_t *, chargrid_t *);
 
-extern errno_t output_cursor_update(async_sess_t *, frontbuf_handle_t);
-extern errno_t output_set_style(async_sess_t *, console_style_t);
+extern int output_cursor_update(async_sess_t *, frontbuf_handle_t);
+extern int output_set_style(async_sess_t *, console_style_t);
 
-extern errno_t output_update(async_sess_t *, frontbuf_handle_t);
-extern errno_t output_damage(async_sess_t *, frontbuf_handle_t,
+extern int output_update(async_sess_t *, frontbuf_handle_t);
+extern int output_damage(async_sess_t *, frontbuf_handle_t,
     sysarg_t, sysarg_t, sysarg_t, sysarg_t);
 
Index: uspace/lib/c/include/io/serial.h
===================================================================
--- uspace/lib/c/include/io/serial.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/io/serial.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,9 +43,9 @@
 } serial_t;
 
-extern errno_t serial_open(async_sess_t *, serial_t **);
+extern int serial_open(async_sess_t *, serial_t **);
 extern void serial_close(serial_t *);
-extern errno_t serial_set_comm_props(serial_t *, unsigned, serial_parity_t,
+extern int serial_set_comm_props(serial_t *, unsigned, serial_parity_t,
     unsigned, unsigned);
-extern errno_t serial_get_comm_props(serial_t *, unsigned *, serial_parity_t *,
+extern int serial_get_comm_props(serial_t *, unsigned *, serial_parity_t *,
     unsigned *, unsigned *);
 
Index: uspace/lib/c/include/io/table.h
===================================================================
--- uspace/lib/c/include/io/table.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/io/table.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,5 +40,4 @@
 #include <stddef.h>
 #include <stdio.h>
-#include <errno.h>
 
 /** Table metrics */
@@ -83,5 +82,5 @@
 	bool header_row;
 	/** Encountered error while writing to table */
-	errno_t error;
+	int error;
 	/** Table rows */
 	list_t rows; /* of table_row_t */
@@ -98,10 +97,10 @@
 } table_t;
 
-extern errno_t table_create(table_t **);
+extern int table_create(table_t **);
 extern void table_destroy(table_t *);
-extern errno_t table_print_out(table_t *, FILE *);
+extern int table_print_out(table_t *, FILE *);
 extern void table_header_row(table_t *);
-extern errno_t table_printf(table_t *, const char *, ...);
-extern errno_t table_get_error(table_t *);
+extern int table_printf(table_t *, const char *, ...);
+extern int table_get_error(table_t *);
 extern void table_set_margin_left(table_t *, size_t);
 
Index: uspace/lib/c/include/io/verify.h
===================================================================
--- uspace/lib/c/include/io/verify.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/io/verify.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,19 +36,19 @@
 #define LIBC_IO_VERIFY_H_
 
-#ifndef _HELENOS_NVERIFY_PRINTF
+#ifndef NVERIFY_PRINTF
 
 #ifdef __clang__
-#define _HELENOS_PRINTF_ATTRIBUTE(start, end) \
+#define PRINTF_ATTRIBUTE(start, end) \
 	__attribute__((format(__printf__, start, end)))
 #else
-#define _HELENOS_PRINTF_ATTRIBUTE(start, end) \
+#define PRINTF_ATTRIBUTE(start, end) \
 	__attribute__((format(gnu_printf, start, end)))
 #endif
 
-#else /* _HELENOS_NVERIFY_PRINTF */
+#else /* NVERIFY_PRINTF */
 
-#define _HELENOS_PRINTF_ATTRIBUTE(start, end)
+#define PRINTF_ATTRIBUTE(start, end)
 
-#endif /* _HELENOS_NVERIFY_PRINTF */
+#endif /* NVERIFY_PRINTF */
 
 #endif
Index: uspace/lib/c/include/io/visualizer.h
===================================================================
--- uspace/lib/c/include/io/visualizer.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/io/visualizer.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,18 +39,18 @@
 #include <io/mode.h>
 
-extern errno_t visualizer_claim(async_sess_t *, sysarg_t);
-extern errno_t visualizer_yield(async_sess_t *);
+extern int visualizer_claim(async_sess_t *, sysarg_t);
+extern int visualizer_yield(async_sess_t *);
 
-extern errno_t visualizer_enumerate_modes(async_sess_t *, vslmode_t *, sysarg_t);
-extern errno_t visualizer_get_default_mode(async_sess_t *, vslmode_t *);
-extern errno_t visualizer_get_current_mode(async_sess_t *, vslmode_t *);
-extern errno_t visualizer_get_mode(async_sess_t *, vslmode_t *, sysarg_t);
-extern errno_t visualizer_set_mode(async_sess_t *, sysarg_t, sysarg_t, void *);
+extern int visualizer_enumerate_modes(async_sess_t *, vslmode_t *, sysarg_t);
+extern int visualizer_get_default_mode(async_sess_t *, vslmode_t *);
+extern int visualizer_get_current_mode(async_sess_t *, vslmode_t *);
+extern int visualizer_get_mode(async_sess_t *, vslmode_t *, sysarg_t);
+extern int visualizer_set_mode(async_sess_t *, sysarg_t, sysarg_t, void *);
 
-extern errno_t visualizer_update_damaged_region(async_sess_t *,
+extern int visualizer_update_damaged_region(async_sess_t *,
     sysarg_t, sysarg_t, sysarg_t, sysarg_t, sysarg_t, sysarg_t);
 
-extern errno_t visualizer_suspend(async_sess_t *);
-extern errno_t visualizer_wakeup(async_sess_t *);
+extern int visualizer_suspend(async_sess_t *);
+extern int visualizer_wakeup(async_sess_t *);
 
 #endif
Index: uspace/lib/c/include/io/window.h
===================================================================
--- uspace/lib/c/include/io/window.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/io/window.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -113,15 +113,15 @@
 } window_event_t;
 
-extern errno_t win_register(async_sess_t *, window_flags_t, service_id_t *,
+extern int win_register(async_sess_t *, window_flags_t, service_id_t *,
     service_id_t *);
 
-extern errno_t win_get_event(async_sess_t *, window_event_t *);
+extern int win_get_event(async_sess_t *, window_event_t *);
 
-extern errno_t win_damage(async_sess_t *, sysarg_t, sysarg_t, sysarg_t, sysarg_t);
-extern errno_t win_grab(async_sess_t *, sysarg_t, sysarg_t);
-extern errno_t win_resize(async_sess_t *, sysarg_t, sysarg_t, sysarg_t, sysarg_t,
+extern int win_damage(async_sess_t *, sysarg_t, sysarg_t, sysarg_t, sysarg_t);
+extern int win_grab(async_sess_t *, sysarg_t, sysarg_t);
+extern int win_resize(async_sess_t *, sysarg_t, sysarg_t, sysarg_t, sysarg_t,
     window_placement_flags_t, void *);
-extern errno_t win_close(async_sess_t *);
-extern errno_t win_close_request(async_sess_t *);
+extern int win_close(async_sess_t *);
+extern int win_close_request(async_sess_t *);
 
 #endif
Index: uspace/lib/c/include/ipc/common.h
===================================================================
--- uspace/lib/c/include/ipc/common.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/ipc/common.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -52,5 +52,4 @@
 	unsigned flags;
 	struct async_call *label;
-	cap_handle_t cap_handle;
 } ipc_call_t;
 
Index: uspace/lib/c/include/ipc/devman.h
===================================================================
--- uspace/lib/c/include/ipc/devman.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/ipc/devman.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -74,5 +74,5 @@
 	/** Id of device model.
 	 */
-	char *id;
+	const char *id;
 	/** Relevancy of device-to-driver match.
 	 * The higher is the product of scores specified for the device by the bus driver and by the leaf driver,
Index: uspace/lib/c/include/ipc/event.h
===================================================================
--- uspace/lib/c/include/ipc/event.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/ipc/event.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,10 +39,10 @@
 #include <types/common.h>
 
-extern errno_t ipc_event_subscribe(event_type_t, sysarg_t);
-extern errno_t ipc_event_task_subscribe(event_task_type_t, sysarg_t);
-extern errno_t ipc_event_unsubscribe(event_type_t);
-extern errno_t ipc_event_task_unsubscribe(event_task_type_t);
-extern errno_t ipc_event_unmask(event_type_t);
-extern errno_t ipc_event_task_unmask(event_task_type_t);
+extern int ipc_event_subscribe(event_type_t, sysarg_t);
+extern int ipc_event_task_subscribe(event_task_type_t, sysarg_t);
+extern int ipc_event_unsubscribe(event_type_t);
+extern int ipc_event_task_unsubscribe(event_task_type_t);
+extern int ipc_event_unmask(event_type_t);
+extern int ipc_event_task_unmask(event_task_type_t);
 
 #endif
